package eighties.h24.run

import better.files.File
import eighties.h24.population.Individual
import eighties.h24.space.{BoundingBox, World}
import eighties.h24.{observable, worldMapper}

object util {
  def mapHealth(world: World, bb: BoundingBox, file: File, textLeft: String, textRight: String, atHome: Boolean = true) = {
    def getValue(individual: Individual) = if (individual.healthy) 1.0 else 0.0
    worldMapper.mapGray(world, bb, file, getValue, atHome, textLeft, textRight)
  }

  def writeState(world: World, file: File, deltaHealth: Option[Double] = None) = {
    file.parent.createDirectories
    file < "effective,healthy,high,highHealty,middle,middleHealthy,low,lowHealthy,socialInequality,e" + (deltaHealth match {
      case None => "\n"
      case Some(_) => ",deltaHealth\n"
    })
    val size = World.individualsVector.get(world).size
    val nbHealthy = World.individualsVector.get(world).count(_.healthy)
    val soc = observable.weightedInequalityRatioBySexAge(world)
    val cat = observable.getCategories(world)
    val e = observable.erreygersE_(cat, size)
    file << s"""$size,$nbHealthy,${cat.numberOfHigh},${cat.numberOfHighHealthy},${cat.numberOfMiddle},${cat.numberOfMiddleHealthy},${cat.numberOfLow},${cat.numberOfLowHealthy},$soc,$e""" + (deltaHealth match {
      case None => ""
      case Some(d) => s""",$d"""
    })
  }

}
